<template>
  <q-tr>
    <td class="text-center">{{ data.id }}</td>

    <td class="text-center">{{ data.refNo }}</td>
    <td class="text-center">
      {{ data.startTime ? dateFormat(data.startTime) : "" }}
    </td>
    <td class="text-center">{{ data.product }}</td>
    <td class="text-center">{{ this.getProvider(data.site) }}</td>
    <td class="text-right">{{ numberFormat(data.bet) }}</td>
    <td class="text-center">
      <p v-if="role < 2 && data.upLine.percent > 0">
        Provider: {{ data.upLine.percent }}%
      </p>
      <p v-if="role < 2 && data.company.percent > 0">
        Smart Bet: {{ data.company.percent }}%
      </p>
      <p v-if="role < 2 && data.owner.percent > 0">
        คอมปะนี: {{ data.owner.percent }}%
      </p>
      <p v-if="role >= 2 && data.upLine.percent > 0">
        คอมปะนี: {{ data.upLine.percent }}%
      </p>
      <p v-if="role <= 3 && data.share.percent > 0">
        ผู้ถือหุ้น: {{ data.share.percent }}%
      </p>
      <p v-if="role <= 4 && data.senior.percent > 0">
        ซีเนียร์: {{ data.senior.percent }}%
      </p>
      <p v-if="data.agent.percent > 0">เอเย่น: {{ data.agent.percent }}%</p>
    </td>
    <q-td
      class="text-right"
      :class="this.bgFunc(numberFormat(data.member.calWinloss))"
      >{{ numberFormat(data.member.calWinloss) }}</q-td
    >

    <q-td
      :class="this.bgFunc(numberFormat(data.agent.winLoss))"
      v-if="role < 6"
      class="text-right"
      >{{ numberFormat(data.agent.winLoss) }}
    </q-td>
    <q-td
      :class="this.bgFunc(numberFormat(data.senior.winLoss))"
      v-if="role < 5"
      class="text-right"
      >{{ numberFormat(data.senior.winLoss) }}
    </q-td>
    <q-td
      :class="this.bgFunc(numberFormat(data.share.winLoss))"
      v-if="role < 4"
      class="text-right"
      >{{ numberFormat(data.share.winLoss) }}
    </q-td>
    <q-td
      :class="this.bgFunc(numberFormat(data.owner.winLoss))"
      v-if="role < 3"
      class="text-right"
      >{{ numberFormat(data.owner.winLoss) }}
    </q-td>
    <!-- <q-td
      :class="this.bgFunc(numberFormat(data.company.winLoss))"
      v-if="role < 2"
      class="text-right"
    >
      {{ numberFormat(data.company.winLoss) }}
    </q-td> -->
    <q-td :class="this.bgFunc(data.upLine.calWinloss)" class="text-right">{{
      data.upLine.calWinloss
    }}</q-td>
    <!-- <q-td :class="this.bgFunc(data.upLine.calWinloss)" class="text-right">{{
      data.upLine.calWinloss
    }}</q-td> -->

    <q-td v-if="role < 2" class="text-right">
      0.00
    </q-td>
  </q-tr>
</template>
<script>
import { mapState } from "vuex";

export default {
  name: "Report-Member-TR",
  props: {
    provider: {
      type: Array,
      default: () => []
    },
    row: {
      type: Object,
      default: () => {
        results: [];
      }
    }
  },
  data() {
    return {
      data: {}
    };
  },

  created() {
    this.renderRow();
  },
  computed: {
    getProvider() {
      return code => {
        const provider = this.provider.find(x => x.code == code);
        if (provider) {
          return provider.name;
        }
        return code;
      };
    },
    ...mapState("auth", ["role"]),
    dateFormat() {
      return date => {
        return new Intl.DateTimeFormat("th-TH", {
          calendar: "iso8601",
          year: "numeric",
          month: "2-digit",
          day: "2-digit",
          hour: "2-digit",
          minute: "2-digit",
          second: "2-digit",
          hourCycle: "h23"
        }).format(new Date(date));
      };
    },
    numberFormat() {
      return (number, digit = 2, comma = true) =>
        new Intl.NumberFormat("en-US", {
          minimumFractionDigits: digit,
          maximumFractionDigits: digit,
          useGrouping: comma
        }).format(number);
    },
    convertToFloat() {
      return number => parseFloat(this.numberFormat(number, 2, false));
    },
    agentWinloss() {
      return data => {
        if (data) {
          return (
            (this.convertToFloat(this.data.member.winLoss) *
              this.convertToFloat(data.percent)) /
            100
          );
        }
        return 0;
      };
    },
    bgFunc() {
      return inValue => {
        const value = this.convertToFloat(inValue.replace(/,/g, ""));
        if (value > 0) {
          return "text-green-8 text-bold";
        }
        if (value == 0) {
          return "";
        }
        return "text-red-10 text-bold";
      };
    }
  },
  methods: {
    getWinLose(level) {
      let report = [...this.data.marketShare];
      let wl = 0;
      if (report?.length === 0) return this.numberFormat(wl.toFixed(2));

      if (level == 6) {
        wl = this.data.winLoss || 0;
        wl = wl * -1;
      } else if (level >= this.role) {
        const targetReport = report.find(x => x.level === level);
        if (targetReport) {
          wl = targetReport.winLoss;
        }
      } else {
        report = report.filter(x => x.level > level);

        wl = report.reverse().reduce((a, b) => a.winLoss - b.winLoss);
      }

      return this.numberFormat(wl.toFixed(2));
    },

    renderRow() {
      const {
        bet,
        id,
        refNo,
        startTime,
        product,
        site,
        marketShare,
        winLoss
      } = this.row;
      this.data = {
        bet,
        id,
        refNo,
        startTime,
        product,
        site,
        marketShare,
        winLoss
      };
      let model = { bet: 0, winLoss: 0, percent: 0 };
      this.data.upLine = Object.assign({}, model);
      this.data.owner = Object.assign(
        {},
        model,
        marketShare.find(x => x.level == 1)
      );

      this.data.company = Object.assign(
        {},
        model,
        marketShare.find(x => x.level == 2)
      );
      this.data.share = Object.assign(
        {},
        model,
        marketShare.find(x => x.level == 3)
      );
      this.data.senior = Object.assign(
        {},
        model,
        marketShare.find(x => x.level == 4)
      );

      this.data.agent = Object.assign(
        {},
        model,
        marketShare.find(x => x.level == 5)
      );
      this.data.member = Object.assign(
        {},
        model,
        marketShare.find(x => x.level == 6)
      );

      this.data.owner.calWinloss = this.numberFormat(
        this.agentWinloss(this.data.owner)
      );

      this.data.company.calWinloss = this.numberFormat(
        this.agentWinloss(this.data.company)
      );

      this.data.share.calWinloss = this.numberFormat(
        this.agentWinloss(this.data.share)
      );
      this.data.senior.calWinloss = this.numberFormat(
        this.agentWinloss(this.data.senior)
      );
      this.data.agent.calWinloss = this.numberFormat(
        this.agentWinloss(this.data.agent)
      );
      this.data.member.calWinloss = this.numberFormat(
        this.data.winLoss == 0 ? 0 : this.data.winLoss * -1
      );
      this.data.upLine.calWinloss = this.data.winLoss;
      let cal = 0;
      let percent = 0;
      let report = [...marketShare];
      report = report.filter(x => {
        return x.level >= this.role;
      });
      report.map(x => {
        cal += x.winLoss;
        percent += x.percent;
      });
      this.data.upLine.calWinloss = this.numberFormat(
        this.data.upLine.calWinloss - cal
      );
      this.data.upLine.percent = 100 - percent;
      // console.log(percent);
      // if (this.role >= 2) {
      //   let percents = [];
      //   if (this.role <= 2) {
      //     percents.push(this.data.owner);
      //   }
      //   if (this.role <= 3) {
      //     percents.push(this.data.share);
      //   }
      //   if (this.role <= 4) {
      //     percents.push(this.data.senior);
      //   }
      //   if (this.role <= 5) {
      //     percents.push(this.data.agent);
      //   }
      //   const percent =
      //     100 -
      //     percents.reduce((sum, obj) => {
      //       if (obj) {
      //         return sum + obj.percent;
      //       }
      //       return sum;
      //     }, 0);
      //   this.data.upLine.percent = percent == 100 ? 0 : percent;
      //   this.data.upLine.calWinloss = this.numberFormat(
      //     this.agentWinloss(this.data.upLine)
      //   );
      // } else if (this.role < 2) {
      //   this.data.company = Object.assign({}, model, report[0]);
      //   const percent =
      //     100 -
      //     [
      //       this.data.agent,
      //       this.data.senior,
      //       this.data.share,
      //       this.data.owner
      //     ].reduce((sum, obj) => sum + obj.percent, 0);
      //   this.data.company.percent = percent == 100 ? 0 : percent;
      //   this.data.upLine.percent = 0;
      //   this.data.company.calWinloss = this.numberFormat(
      //     this.agentWinloss(this.data.company)
      //   );
      //   this.data.upLine.calWinloss = this.numberFormat(
      //     this.agentWinloss(this.data.upLine)
      //   );
      // }

      // this.data = {
      //   id,
      //   username,
      //   role,
      //   currency,
      //   member,
      //   upLine,
      //   agent,
      //   senior
      // }
    }
  },

  watch: {
    row(newValue, oldValue) {
      this.renderRow();
    }
  }
};
</script>
<style lang="scss" scoped></style>
